﻿' RedLetterDayConverter.cs by Charles Petzold, March 2009

Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.Globalization
Imports System.Windows
Imports System.Windows.Data

Namespace RedLetterDays
	Public Class RedLetterDayConverter
		Implements IValueConverter
		Private Shared dict As New Dictionary(Of DateTime, String)()

		Shared Sub New()
			dict.Add(New DateTime(2009, 3, 17), "St. Patrick's Day")
			dict.Add(New DateTime(2009, 3, 20), "First day of spring")
			dict.Add(New DateTime(2009, 4, 1), "April Fools")
			dict.Add(New DateTime(2009, 4, 22), "Earth Day")
			dict.Add(New DateTime(2009, 5, 1), "May Day")
			dict.Add(New DateTime(2009, 5, 10), "Mother's Day")
			dict.Add(New DateTime(2009, 6, 21), "First Day of Summer")
		End Sub

		Public Function Convert(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As CultureInfo) As Object Implements IValueConverter.Convert
			Dim text As String
			If (Not dict.TryGetValue(CDate(value), text)) Then
				text = Nothing
			End If
			Return text
		End Function

		Public Function ConvertBack(ByVal value As Object, ByVal targetType As Type, ByVal parameter As Object, ByVal culture As CultureInfo) As Object Implements IValueConverter.ConvertBack
			Return Nothing
		End Function
	End Class























'
'    public class RedLetterDayLookup : ToolTip
'    {
'
'        public static readonly DependencyProperty DateTimeProperty =
'            DependencyProperty.Register("DateTime",
'                typeof(DateTime),
'                typeof(RedLetterDayLookup),
'                new PropertyMetadata(new DateTime(), OnDateTimeChanged));
'
'        protected static readonly DependencyPropertyKey TextKey =
'            DependencyProperty.RegisterReadOnly("Text",
'                typeof(string),
'                typeof(RedLetterDayLookup),
'                new PropertyMetadata(null));
'
'        public static readonly DependencyProperty TextProperty =
'            TextKey.DependencyProperty;
'
'        public DateTime DateTime
'        {
'            set { SetValue(DateTimeProperty, value); }
'            get { return (DateTime)GetValue(DateTimeProperty); }
'        }
'
'        public string Text
'        {
'            protected set { SetValue(TextKey, value); }
'            get { return (string)GetValue(TextProperty); }
'        }
'
'        static RedLetterDayLookup()
'        {
'            dict.Add(new DateTime(2009, 3, 17), "St. Patrick's Day");
'            dict.Add(new DateTime(2009, 3, 20), "First day of spring");
'
'        }
'
'        static void OnDateTimeChanged(DependencyObject obj,
'                        DependencyPropertyChangedEventArgs args)
'        {
'            string text;
'            dict.TryGetValue((DateTime)args.NewValue, out text);
'            (obj as RedLetterDayLookup).Content = text;                         //  Text = text;
'        }
'    }
' 



End Namespace
